;
; TI-81, 82, 83, 85, 86 Emulator
;
; Project started 08-28-04.
;
; Copyright (C) 2004-2010, by Michael Vincent. All rights reserved.
 INCLUDE "header.inc"
 NOLIST
 INCLUDE "..\ti83plus.inc"
 INCLUDE "..\michael.inc"
 LIST
 INCLUDE "equates.inc"
;DEBUG EQU 1
;Memory map -
;82h - 8000-BFFFh of emulated calculator
;83h - C000-FFFFh of emulated calculator
;84h - miscellaneous page
;		8000-82FFh - Emulated calculator LCD stored while paused
App_Start:
 ifdef DEBUG
 	ld hl,0
	ld (8700h),hl
	ld (8702h),hl
	ld (8787h),hl
 endif
	ld a,(Calculator_ROMs)
	inc a
	ld hl,App_NoROMs
	jp z,App_Error
	in a,(2)
	rla
	ld hl,App_NotSE
	jp nc,App_Error
	;Splash screen here
	B_CALL DelRes
	B_CALL DisableApd
	B_CALL ForceFullScreen
	B_CALL ClrScrnFull
	ld hl,3*256
	ld (currow),hl
	ld hl,Splash_Data
	call putstr
	ld b,3
	call vputcentered
	B_CALL GetKey
 	jp Main_Screen
Emulation_Starting:
	DB "Emulator is     "
	DB "loading...",0
Splash_Data:
	DB "Emu8x v1.10",0
	DB 18,15,"By Michael Vincent",0
	DB 17,50,"Detached Solutions",0
	DB 20,57,"detachedsolutions.com",0
App_Exit:
	B_CALL JForceCmdNoChar
App_NotSE:
	DB "83+ SE or 84+   "
	DB "required.",0
App_Error:
	push hl
	B_CALL ClrScrnFull
	B_CALL HomeUp
	pop hl
	call putstr
	B_CALL GetKey
	jr App_Exit
App_NoROMs:
	DB "No ROMs found",0
Main_CalcList:
	DB "23561"
Main_CalcBase:
	DB "  TI-8",0
Main_1:
	DB "Select a ROM:",0
ROM_Sizes:
	DB 8,13,8,14,2
Store_Text:
	DB "Processing...",0
Recall_Error_Exist:
	DB "At least one    "
	DB "appvar missing.",0
Recall_Error_RAM_1:
	DB "Saved appvars   "
	DB "must be archived",0
Store_Text_Done:
	DB "Saved! Press any"
	DB "key.",0
Emulation_Store_Appvar:
	DB AppVarObj,"TI8xRAM"
Init_82_Bytes:
	ld a,16h
	out (4),a
Set_PC_82_PortInit:
	;F8 into port 2, C0 into port 0, 0A into port 3, FF into port 4
	DB 0F8h,0C0h,0Ah,0FFh
 INCLUDE "tables.asm"
 INCLUDE "ui.asm"
 INCLUDE "opcodes.asm"
SaveDisplay:
	di
	ld b,64
	ld a,07h
	call lcddelay
	out (10h),a
	ld a,80h-1
Slayerloop1:
	push bc
	ld b,0Ch
	inc a
	ld (OP1),a
	call lcddelay
	out (10h),a
	call lcddelay
	ld a,20h
	out (10h),a
	call lcddelay
	in a,(11h)
Slayerloop2:
	call lcddelay
	in a,(11h)
	ld (hl),a
	inc hl
	djnz Slayerloop2
	pop bc
	ld a,(OP1)
	djnz Slayerloop1
	ld a,05h
	call lcddelay
	out (10h),a
	ret
CopyLayer:
	di
	ld b,64
	ld a,07h
	out (10h),a
	ld a,80h-1
layerloop1:
	push bc
	ld b,0Ch
	inc a
	ld (OP1),a
	call lcddelay
	out (10h),a
	call lcddelay
	ld a,20h
	out (10h),a
layerloop2:
	ld a,(hl)
	call lcddelay
	out (11h),a
	inc hl
	djnz layerloop2
	pop bc
	ld a,(OP1)
	djnz layerloop1
	ld a,5
	call lcddelay
	out (10h),a
	ret
lcddelay:
	push af
lcddelayloop:
	in a,(10h)
	add a,a
	jr c,lcddelayloop
	;and 80h		;take the slower approach to burn more clock cycles
	;jr nz,lcddelayloop
	pop af
	ret
putstr:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL PutC
	jr putstr
vputcentered:
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (pencol),de
	djnz vputstr
	ret
vputstr:
	ld a,(hl)
	inc hl
	or a
	jr z,vputcentered
	B_CALL VPutMap
	jr vputstr
 INCLUDE "machine.asm"
