;Interrupt check
Interrupt_Generated:
	ld a,41h
	out (30h),a
	ld a,1
	out (31h),a
	ld a,(interruptspeed)
	out (32h),a
	ld a,0FFh
	out (1),a
	nop
	ld a,0DFh
	out (1),a
	nop
	in a,(1)
	cp 7Fh
	jr nz,Interrupt_Generated_85NoOn
	ld a,0FFh
	out (1),a
	nop
	dec a		;0FEh
	out (1),a
	nop
	nop
	in a,(1)
	cp 0FDh
	jr z,TI85_LCD_Left
	cp 0FDh & 0FBh
	jp z,Emulation_Pause
	cp 0FBh
	jr nz,Interrupt_Generated_85NoOn
	;Scroll right
	ld a,(lcd85offset)
	inc a
	cp 5
	jr z,Interrupt_Generated_85NoOn
	ld (lcd85offset),a
  	jr Interrupt_Generated_85NoOn
TI85_LCD_Left:
	ld a,(lcd85offset)
	or a
	jr z,Interrupt_Generated_85NoOn
	dec a
	ld (lcd85offset),a
Interrupt_Generated_85NoOn:
	ld a,(calculatorModel)
	cp 2
	jp c,Interrupt_Generated_OK
	cp 4
	jp z,Interrupt_Generated_TI81
	;Display LCD?
	ld hl,lcd85status
	ld a,20h
	xor (hl)
	ld (hl),a
	ld d,a
	dec d
	add a,60h
	ld a,0C0h >> 2
	rla
	add a,a
	ld h,a
	ld a,(port0)
	and 3Fh
	add a,h
	ld h,a
	xor a
	out (20h),a
	ld a,0F7h
	out (29h),a
	ld a,7
	out (10h),a
	ld e,20h
	ld c,11h
	ld a,(lcd85offset)
	ld l,a
TI85_LCD_Copy:
	inc d
	ld a,d
	out (10h),a
	ld a,20h
	out (10h),a
	ld b,12
	otir
	inc hl
	inc hl
	inc hl
	inc hl
	dec e
	jr nz,TI85_LCD_Copy
	ld a,1
	out (20h),a
	ld a,17h
	out (29h),a
Interrupt_Generated_OK:
	ld a,(emulatorflags)
	bit interruptsEnabled,a
	jp z,MainEmulation_Loop
	;Interrupts are enabled!
	bit onEnabled,a
	jp z,Interrupt_TimerCheck
	in a,(4)
	bit 3,a
	jr nz,Interrupt_TimerCheck
	ld a,3
	;call lcddelay
	out (10h),a
	ld hl,port3
	res 3,(hl)
Interrupt_Trigger:
	ld hl,emulatorflags
	res interruptsEnabled,(hl)
	bit haltActive,(hl)
	jr z,Interrupt_Trigger_1
	res haltActive,(hl)
	inc ix
	inc iy
Interrupt_Trigger_1:
	ld a,(interruptMode)
	cp 2
	jp nz,Opcode_FF	;IM0 or IM1 - 38h
Interrupt_IM2:
	ld a,(registerI)
	ld h,a
	ld l,0FFh
	call Fetch_Byte_HL
	ld c,e
	inc hl
	call Fetch_Byte_HL
	ld d,e
	ld e,c
	jp Opcode_Call_Interface
Interrupt_TimerCheck:
	ld hl,port3
	set 3,(hl)
	ld a,(emulatorflags)
	bit timerEnabled,a
	jp z,MainEmulation_Loop
	jr Interrupt_Trigger
Interrupt_Generated_TI81:
	ld hl,lcd85status
	ld a,20h
	xor (hl)
	ld (hl),a
	ld d,a
	dec d
	ld h,0E0h>>1
	add a,60h	;00h (C) if A0h. E0h if 80h
	rl h		;E1 if it was A0h. E0 if it was 80h.
	add a,a	;A is now 00h if A0h. C0h if 80h.
	sub 80h	;A is now 80h (C) if A0h. 40h if 80h
	and 80h	;A is now 80h if A0h. 00h if 80h.
	ld l,a
	xor a
	out (20h),a
	ld a,0F7h
	out (29h),a
	ld a,7
	out (10h),a
	ld e,20h
	ld c,11h
TI81_LCD_Copy:
	inc d
	ld a,d
	out (10h),a
	ld a,20h
	out (10h),a
	ld b,12
	otir
	dec e
	jr nz,TI81_LCD_Copy
	ld a,1
	out (20h),a
	ld a,17h
	out (29h),a
	jp Interrupt_Generated_OK
